summaryrefslogtreecommitdiff
path: root/FS/bin/freeside-credit-report
diff options
context:
space:
mode:
authorjeff <jeff>2002-02-22 23:18:34 +0000
committerjeff <jeff>2002-02-22 23:18:34 +0000
commitb50b2e5f94774268c271484f9c07bfe316f95527 (patch)
tree2dec4f5a1b4ed14bc2ae663acd6691e24c1cda9b /FS/bin/freeside-credit-report
parentf96fd39dcc9c2563f8ba2976f7b9d23c0b3fcc29 (diff)
add some reporting features
Diffstat (limited to 'FS/bin/freeside-credit-report')
-rwxr-xr-xFS/bin/freeside-credit-report184
1 files changed, 184 insertions, 0 deletions
diff --git a/FS/bin/freeside-credit-report b/FS/bin/freeside-credit-report
new file mode 100755
index 0000000..4307a21
--- /dev/null
+++ b/FS/bin/freeside-credit-report
@@ -0,0 +1,184 @@
+#!/usr/bin/perl -Tw
+
+use strict;
+use Date::Parse;
+use Time::Local;
+use Getopt::Std;
+use FS::Conf;
+use FS::UID qw(adminsuidsetup);
+use FS::Record qw(qsearch);
+use FS::cust_credit;
+
+# Set the mail program
+my $mail_program = "/usr/sbin/sendmail -t -n";
+
+&untaint_argv; #what it sounds like (eww)
+use vars qw($opt_v $opt_p $opt_e $opt_d $opt_s);
+getopts("vped:s:"); #switches
+
+#we're at now now (and later).
+my($_enddate)= $main::opt_d ? str2time($main::opt_d) : $^T;
+my($_startdate)= $main::opt_s ? str2time($main::opt_s) : $^T;
+
+# Get the current month
+my ($ssec,$smin,$shour,$smday,$smon,$syear) =
+ (localtime($_startdate) )[0,1,2,3,4,5];
+$syear+=1900;
+$smon++;
+
+# Get the current month
+my ($esec,$emin,$ehour,$emday,$emon,$eyear) =
+ (localtime($_enddate) )[0,1,2,3,4,5];
+$eyear+=1900;
+$emon++;
+
+# Login to the database
+my $user = shift or die &usage;
+adminsuidsetup $user;
+
+# Get the needed configuration files
+my $conf = new FS::Conf;
+my $lpr = $conf->config('lpr');
+my $email = $conf->config('email');
+
+my(@cust_credits)=qsearch('cust_credit',{});
+if (scalar(@cust_credits) == 0)
+{
+ exit 1;
+}
+
+# Open print and email pipes
+# $lpr and opt_p for printing
+# $email and opt_e for email
+
+if ($lpr && $main::opt_p)
+{
+ open(LPR, "|$lpr");
+ print LPR qq~ I N H O U S E C R E D I T S for period beginning: $smon/$smday/$syear and ending $emon/$emday/$eyear\n\n~;
+}
+
+if ($email && $main::opt_e)
+{
+ open (MAIL, "|$mail_program");
+ print MAIL <<END
+To: $email
+From: Account Processor
+Subject: In House Credits
+
+
+I N H O U S E C R E D I T S for period beginning: $smon/$smday/$syear and ending $emon/$emday/$eyear
+
+END
+}
+
+my $total = 0;
+
+# Now I can start looping
+foreach my $cust_credit (@cust_credits)
+{
+ my $_date = $cust_credit->getfield('_date');
+ my $amount = $cust_credit->getfield('amount');
+ my $credited = $cust_credit->getfield('credited');
+
+
+ if ($_date >= $_startdate && $_date <= $_enddate) {
+ $total += $amount;
+
+ my ($sec,$min,$hour,$mday,$mon,$year) =
+ (localtime($_date) )[0,1,2,3,4,5];
+ $mon++;
+
+ }
+
+}
+
+if ($main::opt_v) {
+ printf(qq{\n\n%25s%14.2f\n}, "Credits Offered", $total);
+ printf(qq{\n%39s\n%39.2f\n}, "=========", $total);
+}
+
+# Now I need to close LPR and EMAIL if they were open
+if($lpr && $main::opt_p)
+{
+ printf(LPR qq{\n\n%25s%14.2f\n}, "Credits Offered", $total);
+ printf(LPR qq{\n%39s\n%39.2f\n}, "=========", $total);
+ close LPR || die "Could not close printer: $lpr\n";
+}
+if($email && $main::opt_e)
+{
+ printf(MAIL qq{\n\n%25s%14.2f\n}, "Credits Offered", $total);
+ printf(MAIL qq{\n%39s\n%39.2f\n}, "=========", $total);
+ close MAIL || die "Could not close printer: $email\n";
+}
+
+
+# subroutines
+sub untaint_argv {
+ foreach $_ ( $[ .. $#ARGV ) { #untaint @ARGV
+ $ARGV[$_] =~ /^([\w\-\/ :]*)$/ || die "Illegal argument \"$ARGV[$_]\"";
+ $ARGV[$_]=$1;
+ }
+}
+
+sub usage {
+ die "Usage:\n\n freeside-credit-report [-v] [-p] [-e] user\n";
+}
+
+=head1 NAME
+
+freeside-credit-report - Prints or emails in house credits offered in a given period.
+
+=head1 SYNOPSIS
+
+ freeside-credit-report [-v] [-p] [-e] user
+
+=head1 DESCRIPTION
+
+Prints or emails in house credits offered in a given period.
+
+-v: Verbose - Prints records to STDOUT.
+
+-p: Print to printer lpr as found in the conf directory.
+
+-e: Email output to user found in the Conf email file.
+
+user: From the mapsecrets file - see config.html from the base documentation
+
+=head1 VERSION
+
+$Id: freeside-credit-report,v 1.1 2002-02-22 23:18:32 jeff Exp $
+
+=head1 BUGS
+
+Yes..... Use at your own risk. No guarantees or warrantees of any
+kind apply to this program. Parts of this program are hacked from
+other GNU licensed software created mainly by Ivan Kohler.
+
+This is released under the GNU Public License. See www.gnu.org
+for more information regarding this license.
+
+=head1 SEE ALSO
+
+L<FS::cust_main>, config.html from the base documentation
+
+=head1 HISTORY
+
+griff@aver-computer.com July 99
+
+$Log: freeside-credit-report,v $
+Revision 1.1 2002-02-22 23:18:32 jeff
+add some reporting features
+
+Revision 1.1 2002/02/19 14:24:53 jeff
+might be functional now
+
+Revision 1.1 2000/09/20 19:25:19 jeff
+local modifications
+
+Revision 1.1 2000/05/13 21:57:56 ivan
+add print_batch script from Joel Griffiths
+
+
+=cut
+
+